<!---
  This documentation is auto generated by a script.

  Please do not edit this file directly, check compile_docs task on lib/tasks/gitlab/graphql.rake.
--->

# GraphQL API Resources

This documentation is self-generated based on GitLab current GraphQL schema.

The API can be explored interactively using the [GraphiQL IDE](../index.md#graphiql).

Each table below documents a GraphQL type. Types match loosely to models, but not all
fields and methods on a model are available via GraphQL.

CAUTION: **Caution:**
Fields that are deprecated are marked with **{warning-solid}**.

## AccessLevel

Represents the access level of a relationship between a User and object that it is related to

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `integerValue` | Int | Integer representation of access level |
| `stringValue` | AccessLevelEnum | String representation of access level |

## AddAwardEmojiPayload

Autogenerated return type of AddAwardEmoji

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `awardEmoji` | AwardEmoji | The award emoji after mutation |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |

## AddProjectToSecurityDashboardPayload

Autogenerated return type of AddProjectToSecurityDashboard

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `project` | Project | Project that was added to the Instance Security Dashboard |

## AdminSidekiqQueuesDeleteJobsPayload

Autogenerated return type of AdminSidekiqQueuesDeleteJobs

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `result` | DeleteJobsResponse | Information about the status of the deletion request |

## AlertManagementAlert

Describes an alert from the project's Alert Management

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `createdAt` | Time | Timestamp the alert was created |
| `description` | String | Description of the alert |
| `details` | JSON | Alert details |
| `endedAt` | Time | Timestamp the alert ended |
| `eventCount` | Int | Number of events of this alert |
| `hosts` | String! => Array | List of hosts the alert came from |
| `iid` | ID! | Internal ID of the alert |
| `issueIid` | ID | Internal ID of the GitLab issue attached to the alert |
| `metricsDashboardUrl` | String | URL for metrics embed for the alert |
| `monitoringTool` | String | Monitoring tool the alert came from |
| `service` | String | Service the alert came from |
| `severity` | AlertManagementSeverity | Severity of the alert |
| `startedAt` | Time | Timestamp the alert was raised |
| `status` | AlertManagementStatus | Status of the alert |
| `title` | String | Title of the alert |
| `updatedAt` | Time | Timestamp the alert was last updated |

## AlertManagementAlertStatusCountsType

Represents total number of alerts for the represented categories

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `acknowledged` | Int | Number of alerts with status ACKNOWLEDGED for the project |
| `all` | Int | Total number of alerts for the project |
| `ignored` | Int | Number of alerts with status IGNORED for the project |
| `open` | Int | Number of alerts with status TRIGGERED or ACKNOWLEDGED for the project |
| `resolved` | Int | Number of alerts with status RESOLVED for the project |
| `triggered` | Int | Number of alerts with status TRIGGERED for the project |

## AlertSetAssigneesPayload

Autogenerated return type of AlertSetAssignees

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `alert` | AlertManagementAlert | The alert after mutation |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `issue` | Issue | The issue created after mutation |
| `todo` | Todo | The todo after mutation |

## AlertTodoCreatePayload

Autogenerated return type of AlertTodoCreate

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `alert` | AlertManagementAlert | The alert after mutation |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `issue` | Issue | The issue created after mutation |
| `todo` | Todo | The todo after mutation |

## AwardEmoji

An emoji awarded by a user.

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `description` | String! | The emoji description |
| `emoji` | String! | The emoji as an icon |
| `name` | String! | The emoji name |
| `unicode` | String! | The emoji in unicode |
| `unicodeVersion` | String! | The unicode version for this emoji |
| `user` | User! | The user who awarded the emoji |

## AwardEmojiAddPayload

Autogenerated return type of AwardEmojiAdd

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `awardEmoji` | AwardEmoji | The award emoji after mutation |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |

## AwardEmojiRemovePayload

Autogenerated return type of AwardEmojiRemove

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `awardEmoji` | AwardEmoji | The award emoji after mutation |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |

## AwardEmojiTogglePayload

Autogenerated return type of AwardEmojiToggle

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `awardEmoji` | AwardEmoji | The award emoji after mutation |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `toggledOn` | Boolean! | Indicates the status of the emoji. True if the toggle awarded the emoji, and false if the toggle removed the emoji. |

## BaseService

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `active` | Boolean | Indicates if the service is active |
| `type` | String | Class name of the service |

## Blob

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `flatPath` | String! | Flat path of the entry |
| `id` | ID! | ID of the entry |
| `lfsOid` | String | LFS ID of the blob |
| `mode` | String | Blob mode in numeric format |
| `name` | String! | Name of the entry |
| `path` | String! | Path of the entry |
| `sha` | String! | Last commit sha for the entry |
| `type` | EntryType! | Type of tree entry |
| `webPath` | String | Web path of the blob |
| `webUrl` | String | Web URL of the blob |

## Board

Represents a project or group board

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `id` | ID! | ID (global ID) of the board |
| `name` | String | Name of the board |
| `weight` | Int | Weight of the board |

## BoardList

Represents a list for an issue board

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `assignee` | User | Assignee in the list |
| `collapsed` | Boolean | Indicates if list is collapsed for this user |
| `id` | ID! | ID (global ID) of the list |
| `label` | Label | Label of the list |
| `limitMetric` | ListLimitMetric | The current limit metric for the list |
| `listType` | String! | Type of the list |
| `maxIssueCount` | Int | Maximum number of issues in the list |
| `maxIssueWeight` | Int | Maximum weight of issues in the list |
| `milestone` | Milestone | Milestone of the list |
| `position` | Int | Position of list within the board |
| `title` | String! | Title of the list |

## BoardListUpdateLimitMetricsPayload

Autogenerated return type of BoardListUpdateLimitMetrics

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `list` | BoardList | The updated list |

## Branch

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `commit` | Commit | Commit for the branch |
| `name` | String! | Name of the branch |

## Commit

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `author` | User | Author of the commit |
| `authorGravatar` | String | Commit authors gravatar |
| `authorName` | String | Commit authors name |
| `authoredDate` | Time | Timestamp of when the commit was authored |
| `description` | String | Description of the commit message |
| `descriptionHtml` | String | The GitLab Flavored Markdown rendering of `description` |
| `id` | ID! | ID (global ID) of the commit |
| `latestPipeline` **{warning-solid}** | Pipeline | **Deprecated:** Use `pipelines`. Deprecated in 12.5 |
| `message` | String | Raw commit message |
| `sha` | String! | SHA1 ID of the commit |
| `signatureHtml` | String | Rendered HTML of the commit signature |
| `title` | String | Title of the commit message |
| `titleHtml` | String | The GitLab Flavored Markdown rendering of `title` |
| `webPath` | String! | Web path of the commit |
| `webUrl` | String! | Web URL of the commit |

## CommitCreatePayload

Autogenerated return type of CommitCreate

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `commit` | Commit | The commit after mutation |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |

## ComplianceFramework

Represents a ComplianceFramework associated with a Project

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `name` | ProjectSettingEnum! | Name of the compliance framework |

## ContainerExpirationPolicy

A tag expiration policy designed to keep only the images that matter most

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `cadence` | ContainerExpirationPolicyCadenceEnum! | This container expiration policy schedule |
| `createdAt` | Time! | Timestamp of when the container expiration policy was created |
| `enabled` | Boolean! | Indicates whether this container expiration policy is enabled |
| `keepN` | ContainerExpirationPolicyKeepEnum | Number of tags to retain |
| `nameRegex` | UntrustedRegexp | Tags with names matching this regex pattern will expire |
| `nameRegexKeep` | UntrustedRegexp | Tags with names matching this regex pattern will be preserved |
| `nextRunAt` | Time | Next time that this container expiration policy will get executed |
| `olderThan` | ContainerExpirationPolicyOlderThanEnum | Tags older that this will expire |
| `updatedAt` | Time! | Timestamp of when the container expiration policy was updated |

## CreateAlertIssuePayload

Autogenerated return type of CreateAlertIssue

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `alert` | AlertManagementAlert | The alert after mutation |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `issue` | Issue | The issue created after mutation |
| `todo` | Todo | The todo after mutation |

## CreateAnnotationPayload

Autogenerated return type of CreateAnnotation

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `annotation` | MetricsDashboardAnnotation | The created annotation |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |

## CreateBranchPayload

Autogenerated return type of CreateBranch

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `branch` | Branch | Branch after mutation |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |

## CreateDiffNotePayload

Autogenerated return type of CreateDiffNote

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `note` | Note | The note after mutation |

## CreateEpicPayload

Autogenerated return type of CreateEpic

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `epic` | Epic | The created epic |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |

## CreateImageDiffNotePayload

Autogenerated return type of CreateImageDiffNote

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `note` | Note | The note after mutation |

## CreateIterationPayload

Autogenerated return type of CreateIteration

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `iteration` | Iteration | The created iteration |

## CreateNotePayload

Autogenerated return type of CreateNote

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `note` | Note | The note after mutation |

## CreateRequirementPayload

Autogenerated return type of CreateRequirement

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `requirement` | Requirement | The requirement after mutation |

## CreateSnippetPayload

Autogenerated return type of CreateSnippet

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `snippet` | Snippet | The snippet after mutation |

## DastSiteProfileCreatePayload

Autogenerated return type of DastSiteProfileCreate

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `id` | ID | ID of the site profile. |

## DeleteAnnotationPayload

Autogenerated return type of DeleteAnnotation

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |

## DeleteJobsResponse

The response from the AdminSidekiqQueuesDeleteJobs mutation.

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `completed` | Boolean | Whether or not the entire queue was processed in time; if not, retrying the same request is safe |
| `deletedJobs` | Int | The number of matching jobs deleted |
| `queueSize` | Int | The queue size after processing |

## Design

A single design

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `diffRefs` | DiffRefs! | The diff refs for this design |
| `event` | DesignVersionEvent! | How this design was changed in the current version |
| `filename` | String! | The filename of the design |
| `fullPath` | String! | The full path to the design file |
| `id` | ID! | The ID of this design |
| `image` | String! | The URL of the full-sized image |
| `imageV432x230` | String | The URL of the design resized to fit within the bounds of 432x230. This will be `null` if the image has not been generated |
| `issue` | Issue! | The issue the design belongs to |
| `notesCount` | Int! | The total count of user-created notes for this design |
| `project` | Project! | The project the design belongs to |

## DesignAtVersion

A design pinned to a specific version. The image field reflects the design as of the associated version.

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `design` | Design! | The underlying design. |
| `diffRefs` | DiffRefs! | The diff refs for this design |
| `event` | DesignVersionEvent! | How this design was changed in the current version |
| `filename` | String! | The filename of the design |
| `fullPath` | String! | The full path to the design file |
| `id` | ID! | The ID of this design |
| `image` | String! | The URL of the full-sized image |
| `imageV432x230` | String | The URL of the design resized to fit within the bounds of 432x230. This will be `null` if the image has not been generated |
| `issue` | Issue! | The issue the design belongs to |
| `notesCount` | Int! | The total count of user-created notes for this design |
| `project` | Project! | The project the design belongs to |
| `version` | DesignVersion! | The version this design-at-versions is pinned to |

## DesignCollection

A collection of designs.

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `design` | Design | Find a specific design |
| `designAtVersion` | DesignAtVersion | Find a design as of a version |
| `issue` | Issue! | Issue associated with the design collection |
| `project` | Project! | Project associated with the design collection |
| `version` | DesignVersion | A specific version |

## DesignManagement

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `designAtVersion` | DesignAtVersion | Find a design as of a version |
| `version` | DesignVersion | Find a version |

## DesignManagementDeletePayload

Autogenerated return type of DesignManagementDelete

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `version` | DesignVersion | The new version in which the designs are deleted |

## DesignManagementUploadPayload

Autogenerated return type of DesignManagementUpload

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `designs` | Design! => Array | The designs that were uploaded by the mutation |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `skippedDesigns` | Design! => Array | Any designs that were skipped from the upload due to there being no change to their content since their last version |

## DesignVersion

A specific version in which designs were added, modified or deleted

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `designAtVersion` | DesignAtVersion! | A particular design as of this version, provided it is visible at this version |
| `id` | ID! | ID of the design version |
| `sha` | ID! | SHA of the design version |

## DestroyNotePayload

Autogenerated return type of DestroyNote

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `note` | Note | The note after mutation |

## DestroySnippetPayload

Autogenerated return type of DestroySnippet

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `snippet` | Snippet | The snippet after mutation |

## DetailedStatus

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `detailsPath` | String! | Path of the details for the pipeline status |
| `favicon` | String! | Favicon of the pipeline status |
| `group` | String! | Group of the pipeline status |
| `hasDetails` | Boolean! | Indicates if the pipeline status has further details |
| `icon` | String! | Icon of the pipeline status |
| `label` | String! | Label of the pipeline status |
| `text` | String! | Text of the pipeline status |
| `tooltip` | String! | Tooltip associated with the pipeline status |

## DiffPosition

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `diffRefs` | DiffRefs! | Information about the branch, HEAD, and base at the time of commenting |
| `filePath` | String! | Path of the file that was changed |
| `height` | Int | Total height of the image |
| `newLine` | Int | Line on HEAD SHA that was changed |
| `newPath` | String | Path of the file on the HEAD SHA |
| `oldLine` | Int | Line on start SHA that was changed |
| `oldPath` | String | Path of the file on the start SHA |
| `positionType` | DiffPositionType! | Type of file the position refers to |
| `width` | Int | Total width of the image |
| `x` | Int | X position of the note |
| `y` | Int | Y position of the note |

## DiffRefs

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `baseSha` | String | Merge base of the branch the comment was made on |
| `headSha` | String! | SHA of the HEAD at the time the comment was made |
| `startSha` | String! | SHA of the branch being compared against |

## DiffStats

Changes to a single file

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `additions` | Int! | Number of lines added to this file |
| `deletions` | Int! | Number of lines deleted from this file |
| `path` | String! | File path, relative to repository root |

## DiffStatsSummary

Aggregated summary of changes

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `additions` | Int! | Number of lines added |
| `changes` | Int! | Number of lines changed |
| `deletions` | Int! | Number of lines deleted |
| `fileCount` | Int! | Number of files changed |

## Discussion

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `createdAt` | Time! | Timestamp of the discussion's creation |
| `id` | ID! | ID of this discussion |
| `replyId` | ID! | ID used to reply to this discussion |
| `resolvable` | Boolean! | Indicates if the object can be resolved |
| `resolved` | Boolean! | Indicates if the object is resolved |
| `resolvedAt` | Time | Timestamp of when the object was resolved |
| `resolvedBy` | User | User who resolved the object |

## DiscussionToggleResolvePayload

Autogenerated return type of DiscussionToggleResolve

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `discussion` | Discussion | The discussion after mutation |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |

## DismissVulnerabilityPayload

Autogenerated return type of DismissVulnerability

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `vulnerability` | Vulnerability | The vulnerability after dismissal |

## Environment

Describes where code is deployed for a project

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `id` | ID! | ID of the environment |
| `metricsDashboard` | MetricsDashboard | Metrics dashboard schema for the environment |
| `name` | String! | Human-readable name of the environment |
| `state` | String! | State of the environment, for example: available/stopped |

## Epic

Represents an epic.

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `author` | User! | Author of the epic |
| `closedAt` | Time | Timestamp of the epic's closure |
| `confidential` | Boolean | Indicates if the epic is confidential |
| `createdAt` | Time | Timestamp of the epic's creation |
| `descendantCounts` | EpicDescendantCount | Number of open and closed descendant epics and issues |
| `descendantWeightSum` | EpicDescendantWeights | Total weight of open and closed issues in the epic and its descendants |
| `description` | String | Description of the epic |
| `downvotes` | Int! | Number of downvotes the epic has received |
| `dueDate` | Time | Due date of the epic |
| `dueDateFixed` | Time | Fixed due date of the epic |
| `dueDateFromMilestones` | Time | Inherited due date of the epic from milestones |
| `dueDateIsFixed` | Boolean | Indicates if the due date has been manually set |
| `group` | Group! | Group to which the epic belongs |
| `hasChildren` | Boolean! | Indicates if the epic has children |
| `hasIssues` | Boolean! | Indicates if the epic has direct issues |
| `hasParent` | Boolean! | Indicates if the epic has a parent epic |
| `healthStatus` | EpicHealthStatus | Current health status of the epic |
| `id` | ID! | ID of the epic |
| `iid` | ID! | Internal ID of the epic |
| `parent` | Epic | Parent epic of the epic |
| `reference` | String! | Internal reference of the epic. Returned in shortened format by default |
| `relationPath` | String | URI path of the epic-issue relationship |
| `relativePosition` | Int | The relative position of the epic in the epic tree |
| `startDate` | Time | Start date of the epic |
| `startDateFixed` | Time | Fixed start date of the epic |
| `startDateFromMilestones` | Time | Inherited start date of the epic from milestones |
| `startDateIsFixed` | Boolean | Indicates if the start date has been manually set |
| `state` | EpicState! | State of the epic |
| `subscribed` | Boolean! | Indicates the currently logged in user is subscribed to the epic |
| `title` | String | Title of the epic |
| `updatedAt` | Time | Timestamp of the epic's last activity |
| `upvotes` | Int! | Number of upvotes the epic has received |
| `userPermissions` | EpicPermissions! | Permissions for the current user on the resource |
| `webPath` | String! | Web path of the epic |
| `webUrl` | String! | Web URL of the epic |

## EpicAddIssuePayload

Autogenerated return type of EpicAddIssue

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `epic` | Epic | The epic after mutation |
| `epicIssue` | EpicIssue | The epic-issue relation |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |

## EpicDescendantCount

Counts of descendent epics.

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `closedEpics` | Int | Number of closed sub-epics |
| `closedIssues` | Int | Number of closed epic issues |
| `openedEpics` | Int | Number of opened sub-epics |
| `openedIssues` | Int | Number of opened epic issues |

## EpicDescendantWeights

Total weight of open and closed descendant issues

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `closedIssues` | Int | Total weight of completed (closed) issues in this epic, including epic descendants |
| `openedIssues` | Int | Total weight of opened issues in this epic, including epic descendants |

## EpicHealthStatus

Health status of child issues

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `issuesAtRisk` | Int | Number of issues at risk |
| `issuesNeedingAttention` | Int | Number of issues that need attention |
| `issuesOnTrack` | Int | Number of issues on track |

## EpicIssue

Relationship between an epic and an issue

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `author` | User! | User that created the issue |
| `closedAt` | Time | Timestamp of when the issue was closed |
| `confidential` | Boolean! | Indicates the issue is confidential |
| `createdAt` | Time! | Timestamp of when the issue was created |
| `description` | String | Description of the issue |
| `descriptionHtml` | String | The GitLab Flavored Markdown rendering of `description` |
| `designCollection` | DesignCollection | Collection of design images associated with this issue |
| `designs` **{warning-solid}** | DesignCollection | **Deprecated:** Use `designCollection`. Deprecated in 12.2 |
| `discussionLocked` | Boolean! | Indicates discussion is locked on the issue |
| `downvotes` | Int! | Number of downvotes the issue has received |
| `dueDate` | Time | Due date of the issue |
| `epic` | Epic | Epic to which this issue belongs |
| `epicIssueId` | ID! | ID of the epic-issue relation |
| `healthStatus` | HealthStatus | Current health status. Returns null if `save_issuable_health_status` feature flag is disabled. |
| `id` | ID | Global ID of the epic-issue relation |
| `iid` | ID! | Internal ID of the issue |
| `iteration` | Iteration | Iteration of the issue |
| `milestone` | Milestone | Milestone of the issue |
| `reference` | String! | Internal reference of the issue. Returned in shortened format by default |
| `relationPath` | String | URI path of the epic-issue relation |
| `relativePosition` | Int | Relative position of the issue (used for positioning in epic tree and issue boards) |
| `state` | IssueState! | State of the issue |
| `subscribed` | Boolean! | Indicates the currently logged in user is subscribed to the issue |
| `taskCompletionStatus` | TaskCompletionStatus! | Task completion status of the issue |
| `timeEstimate` | Int! | Time estimate of the issue |
| `title` | String! | Title of the issue |
| `titleHtml` | String | The GitLab Flavored Markdown rendering of `title` |
| `totalTimeSpent` | Int! | Total time reported as spent on the issue |
| `updatedAt` | Time! | Timestamp of when the issue was last updated |
| `upvotes` | Int! | Number of upvotes the issue has received |
| `userNotesCount` | Int! | Number of user notes of the issue |
| `userPermissions` | IssuePermissions! | Permissions for the current user on the resource |
| `webPath` | String! | Web path of the issue |
| `webUrl` | String! | Web URL of the issue |
| `weight` | Int | Weight of the issue |

## EpicPermissions

Check permissions for the current user on an epic

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `adminEpic` | Boolean! | Indicates the user can perform `admin_epic` on this resource |
| `awardEmoji` | Boolean! | Indicates the user can perform `award_emoji` on this resource |
| `createEpic` | Boolean! | Indicates the user can perform `create_epic` on this resource |
| `createNote` | Boolean! | Indicates the user can perform `create_note` on this resource |
| `destroyEpic` | Boolean! | Indicates the user can perform `destroy_epic` on this resource |
| `readEpic` | Boolean! | Indicates the user can perform `read_epic` on this resource |
| `readEpicIid` | Boolean! | Indicates the user can perform `read_epic_iid` on this resource |
| `updateEpic` | Boolean! | Indicates the user can perform `update_epic` on this resource |

## EpicSetSubscriptionPayload

Autogenerated return type of EpicSetSubscription

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `epic` | Epic | The epic after mutation |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |

## EpicTreeReorderPayload

Autogenerated return type of EpicTreeReorder

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |

## GeoNode

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `containerRepositoriesMaxCapacity` | Int | The maximum concurrency of container repository sync for this secondary node |
| `enabled` | Boolean | Indicates whether this Geo node is enabled |
| `filesMaxCapacity` | Int | The maximum concurrency of LFS/attachment backfill for this secondary node |
| `id` | ID! | ID of this GeoNode |
| `internalUrl` | String | The URL defined on the primary node that secondary nodes should use to contact it |
| `minimumReverificationInterval` | Int | The interval (in days) in which the repository verification is valid. Once expired, it will be reverified |
| `name` | String | The unique identifier for this Geo node |
| `primary` | Boolean | Indicates whether this Geo node is the primary |
| `reposMaxCapacity` | Int | The maximum concurrency of repository backfill for this secondary node |
| `selectiveSyncShards` | String! => Array | The repository storages whose projects should be synced, if `selective_sync_type` == `shards` |
| `selectiveSyncType` | String | Indicates if syncing is limited to only specific groups, or shards |
| `syncObjectStorage` | Boolean | Indicates if this secondary node will replicate blobs in Object Storage |
| `url` | String | The user-facing URL for this Geo node |
| `verificationMaxCapacity` | Int | The maximum concurrency of repository verification for this secondary node |

## GrafanaIntegration

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `createdAt` | Time! | Timestamp of the issue's creation |
| `enabled` | Boolean! | Indicates whether Grafana integration is enabled |
| `grafanaUrl` | String! | URL for the Grafana host for the Grafana integration |
| `id` | ID! | Internal ID of the Grafana integration |
| `token` **{warning-solid}** | String! | **Deprecated:** Plain text token has been masked for security reasons. Deprecated in 12.7 |
| `updatedAt` | Time! | Timestamp of the issue's last activity |

## Group

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `autoDevopsEnabled` | Boolean | Indicates whether Auto DevOps is enabled for all projects within this group |
| `avatarUrl` | String | Avatar URL of the group |
| `board` | Board | A single board of the group |
| `description` | String | Description of the namespace |
| `descriptionHtml` | String | The GitLab Flavored Markdown rendering of `description` |
| `emailsDisabled` | Boolean | Indicates if a group has email notifications disabled |
| `epic` | Epic | Find a single epic |
| `epicsEnabled` | Boolean | Indicates if Epics are enabled for namespace |
| `fullName` | String! | Full name of the namespace |
| `fullPath` | ID! | Full path of the namespace |
| `groupTimelogsEnabled` | Boolean | Indicates if Group timelogs are enabled for namespace |
| `id` | ID! | ID of the namespace |
| `label` | Label | A label available on this group |
| `lfsEnabled` | Boolean | Indicates if Large File Storage (LFS) is enabled for namespace |
| `mentionsDisabled` | Boolean | Indicates if a group is disabled from getting mentioned |
| `name` | String! | Name of the namespace |
| `parent` | Group | Parent group |
| `path` | String! | Path of the namespace |
| `projectCreationLevel` | String | The permission level required to create projects in the group |
| `requestAccessEnabled` | Boolean | Indicates if users can request access to namespace |
| `requireTwoFactorAuthentication` | Boolean | Indicates if all users in this group are required to set up two-factor authentication |
| `rootStorageStatistics` | RootStorageStatistics | Aggregated storage statistics of the namespace. Only available for root namespaces |
| `shareWithGroupLock` | Boolean | Indicates if sharing a project with another group within this group is prevented |
| `storageSizeLimit` | Float | Total storage limit of the root namespace in bytes |
| `subgroupCreationLevel` | String | The permission level required to create subgroups within the group |
| `temporaryStorageIncreaseEndsOn` | Time | Date until the temporary storage increase is active |
| `twoFactorGracePeriod` | Int | Time before two-factor authentication is enforced |
| `userPermissions` | GroupPermissions! | Permissions for the current user on the resource |
| `visibility` | String | Visibility of the namespace |
| `webUrl` | String! | Web URL of the group |

## GroupMember

Represents a Group Member

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `accessLevel` | AccessLevel | GitLab::Access level |
| `createdAt` | Time | Date and time the membership was created |
| `createdBy` | User | User that authorized membership |
| `expiresAt` | Time | Date and time the membership expires |
| `group` | Group | Group that a User is a member of |
| `updatedAt` | Time | Date and time the membership was last updated |
| `userPermissions` | GroupPermissions! | Permissions for the current user on the resource |

## GroupPermissions

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `readGroup` | Boolean! | Indicates the user can perform `read_group` on this resource |

## Issue

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `author` | User! | User that created the issue |
| `closedAt` | Time | Timestamp of when the issue was closed |
| `confidential` | Boolean! | Indicates the issue is confidential |
| `createdAt` | Time! | Timestamp of when the issue was created |
| `description` | String | Description of the issue |
| `descriptionHtml` | String | The GitLab Flavored Markdown rendering of `description` |
| `designCollection` | DesignCollection | Collection of design images associated with this issue |
| `designs` **{warning-solid}** | DesignCollection | **Deprecated:** Use `designCollection`. Deprecated in 12.2 |
| `discussionLocked` | Boolean! | Indicates discussion is locked on the issue |
| `downvotes` | Int! | Number of downvotes the issue has received |
| `dueDate` | Time | Due date of the issue |
| `epic` | Epic | Epic to which this issue belongs |
| `healthStatus` | HealthStatus | Current health status. Returns null if `save_issuable_health_status` feature flag is disabled. |
| `id` | ID! | ID of the issue |
| `iid` | ID! | Internal ID of the issue |
| `iteration` | Iteration | Iteration of the issue |
| `milestone` | Milestone | Milestone of the issue |
| `reference` | String! | Internal reference of the issue. Returned in shortened format by default |
| `relativePosition` | Int | Relative position of the issue (used for positioning in epic tree and issue boards) |
| `state` | IssueState! | State of the issue |
| `subscribed` | Boolean! | Indicates the currently logged in user is subscribed to the issue |
| `taskCompletionStatus` | TaskCompletionStatus! | Task completion status of the issue |
| `timeEstimate` | Int! | Time estimate of the issue |
| `title` | String! | Title of the issue |
| `titleHtml` | String | The GitLab Flavored Markdown rendering of `title` |
| `totalTimeSpent` | Int! | Total time reported as spent on the issue |
| `updatedAt` | Time! | Timestamp of when the issue was last updated |
| `upvotes` | Int! | Number of upvotes the issue has received |
| `userNotesCount` | Int! | Number of user notes of the issue |
| `userPermissions` | IssuePermissions! | Permissions for the current user on the resource |
| `webPath` | String! | Web path of the issue |
| `webUrl` | String! | Web URL of the issue |
| `weight` | Int | Weight of the issue |

## IssuePermissions

Check permissions for the current user on a issue

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `adminIssue` | Boolean! | Indicates the user can perform `admin_issue` on this resource |
| `createDesign` | Boolean! | Indicates the user can perform `create_design` on this resource |
| `createNote` | Boolean! | Indicates the user can perform `create_note` on this resource |
| `destroyDesign` | Boolean! | Indicates the user can perform `destroy_design` on this resource |
| `readDesign` | Boolean! | Indicates the user can perform `read_design` on this resource |
| `readIssue` | Boolean! | Indicates the user can perform `read_issue` on this resource |
| `reopenIssue` | Boolean! | Indicates the user can perform `reopen_issue` on this resource |
| `updateIssue` | Boolean! | Indicates the user can perform `update_issue` on this resource |

## IssueSetConfidentialPayload

Autogenerated return type of IssueSetConfidential

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `issue` | Issue | The issue after mutation |

## IssueSetDueDatePayload

Autogenerated return type of IssueSetDueDate

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `issue` | Issue | The issue after mutation |

## IssueSetIterationPayload

Autogenerated return type of IssueSetIteration

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `issue` | Issue | The issue after mutation |

## IssueSetLockedPayload

Autogenerated return type of IssueSetLocked

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `issue` | Issue | The issue after mutation |

## IssueSetWeightPayload

Autogenerated return type of IssueSetWeight

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `issue` | Issue | The issue after mutation |

## Iteration

Represents an iteration object.

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `createdAt` | Time! | Timestamp of iteration creation |
| `description` | String | Description of the iteration |
| `dueDate` | Time | Timestamp of the iteration due date |
| `id` | ID! | ID of the iteration |
| `iid` | ID! | Internal ID of the iteration |
| `startDate` | Time | Timestamp of the iteration start date |
| `state` | IterationState! | State of the iteration |
| `title` | String! | Title of the iteration |
| `updatedAt` | Time! | Timestamp of last iteration update |
| `webPath` | String! | Web path of the iteration |
| `webUrl` | String! | Web URL of the iteration |

## JiraImport

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `createdAt` | Time | Timestamp of when the Jira import was created |
| `failedToImportCount` | Int! | Count of issues that failed to import |
| `importedIssuesCount` | Int! | Count of issues that were successfully imported |
| `jiraProjectKey` | String! | Project key for the imported Jira project |
| `scheduledAt` | Time | Timestamp of when the Jira import was scheduled |
| `scheduledBy` | User | User that started the Jira import |
| `totalIssueCount` | Int! | Total count of issues that were attempted to import |

## JiraImportStartPayload

Autogenerated return type of JiraImportStart

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `jiraImport` | JiraImport | The Jira import data after mutation |

## JiraImportUsersPayload

Autogenerated return type of JiraImportUsers

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `jiraUsers` | JiraUser! => Array | Users returned from Jira, matched by email and name if possible. |

## JiraProject

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `key` | String! | Key of the Jira project |
| `name` | String | Name of the Jira project |
| `projectId` | Int! | ID of the Jira project |

## JiraService

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `active` | Boolean | Indicates if the service is active |
| `projects` | JiraProjectConnection | List of all Jira projects fetched through Jira REST API |
| `type` | String | Class name of the service |

## JiraUser

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `gitlabId` | Int | ID of the matched GitLab user |
| `gitlabName` | String | Name of the matched GitLab user |
| `gitlabUsername` | String | Username of the matched GitLab user |
| `jiraAccountId` | String! | Account id of the Jira user |
| `jiraDisplayName` | String! | Display name of the Jira user |
| `jiraEmail` | String | Email of the Jira user, returned only for users with public emails |

## Label

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `color` | String! | Background color of the label |
| `description` | String | Description of the label (Markdown rendered as HTML for caching) |
| `descriptionHtml` | String | The GitLab Flavored Markdown rendering of `description` |
| `id` | ID! | Label ID |
| `textColor` | String! | Text color of the label |
| `title` | String! | Content of the label |

## MarkAsSpamSnippetPayload

Autogenerated return type of MarkAsSpamSnippet

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `snippet` | Snippet | The snippet after mutation |

## MergeRequest

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `allowCollaboration` | Boolean | Indicates if members of the target project can push to the fork |
| `author` | User | User who created this merge request |
| `createdAt` | Time! | Timestamp of when the merge request was created |
| `defaultMergeCommitMessage` | String | Default merge commit message of the merge request |
| `description` | String | Description of the merge request (Markdown rendered as HTML for caching) |
| `descriptionHtml` | String | The GitLab Flavored Markdown rendering of `description` |
| `diffHeadSha` | String | Diff head SHA of the merge request |
| `diffRefs` | DiffRefs | References of the base SHA, the head SHA, and the start SHA for this merge request |
| `diffStats` | DiffStats! => Array | Details about which files were changed in this merge request |
| `diffStatsSummary` | DiffStatsSummary | Summary of which files were changed in this merge request |
| `discussionLocked` | Boolean! | Indicates if comments on the merge request are locked to members only |
| `downvotes` | Int! | Number of downvotes for the merge request |
| `forceRemoveSourceBranch` | Boolean | Indicates if the project settings will lead to source branch deletion after merge |
| `headPipeline` | Pipeline | The pipeline running on the branch HEAD of the merge request |
| `id` | ID! | ID of the merge request |
| `iid` | String! | Internal ID of the merge request |
| `inProgressMergeCommitSha` | String | Commit SHA of the merge request if merge is in progress |
| `mergeCommitMessage` **{warning-solid}** | String | **Deprecated:** Use `defaultMergeCommitMessage`. Deprecated in 11.8 |
| `mergeCommitSha` | String | SHA of the merge request commit (set once merged) |
| `mergeError` | String | Error message due to a merge error |
| `mergeOngoing` | Boolean! | Indicates if a merge is currently occurring |
| `mergeStatus` | String | Status of the merge request |
| `mergeWhenPipelineSucceeds` | Boolean | Indicates if the merge has been set to be merged when its pipeline succeeds (MWPS) |
| `mergeableDiscussionsState` | Boolean | Indicates if all discussions in the merge request have been resolved, allowing the merge request to be merged |
| `mergedAt` | Time | Timestamp of when the merge request was merged, null if not merged |
| `milestone` | Milestone | The milestone of the merge request |
| `project` | Project! | Alias for target_project |
| `projectId` | Int! | ID of the merge request project |
| `rebaseCommitSha` | String | Rebase commit SHA of the merge request |
| `rebaseInProgress` | Boolean! | Indicates if there is a rebase currently in progress for the merge request |
| `reference` | String! | Internal reference of the merge request. Returned in shortened format by default |
| `shouldBeRebased` | Boolean! | Indicates if the merge request will be rebased |
| `shouldRemoveSourceBranch` | Boolean | Indicates if the source branch of the merge request will be deleted after merge |
| `sourceBranch` | String! | Source branch of the merge request |
| `sourceBranchExists` | Boolean! | Indicates if the source branch of the merge request exists |
| `sourceProject` | Project | Source project of the merge request |
| `sourceProjectId` | Int | ID of the merge request source project |
| `state` | MergeRequestState! | State of the merge request |
| `subscribed` | Boolean! | Indicates if the currently logged in user is subscribed to this merge request |
| `targetBranch` | String! | Target branch of the merge request |
| `targetBranchExists` | Boolean! | Indicates if the target branch of the merge request exists |
| `targetProject` | Project! | Target project of the merge request |
| `targetProjectId` | Int! | ID of the merge request target project |
| `taskCompletionStatus` | TaskCompletionStatus! | Completion status of tasks |
| `timeEstimate` | Int! | Time estimate of the merge request |
| `title` | String! | Title of the merge request |
| `titleHtml` | String | The GitLab Flavored Markdown rendering of `title` |
| `totalTimeSpent` | Int! | Total time reported as spent on the merge request |
| `updatedAt` | Time! | Timestamp of when the merge request was last updated |
| `upvotes` | Int! | Number of upvotes for the merge request |
| `userNotesCount` | Int | User notes count of the merge request |
| `userPermissions` | MergeRequestPermissions! | Permissions for the current user on the resource |
| `webUrl` | String | Web URL of the merge request |
| `workInProgress` | Boolean! | Indicates if the merge request is a work in progress (WIP) |

## MergeRequestCreatePayload

Autogenerated return type of MergeRequestCreate

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `mergeRequest` | MergeRequest | The merge request after mutation |

## MergeRequestPermissions

Check permissions for the current user on a merge request

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `adminMergeRequest` | Boolean! | Indicates the user can perform `admin_merge_request` on this resource |
| `cherryPickOnCurrentMergeRequest` | Boolean! | Indicates the user can perform `cherry_pick_on_current_merge_request` on this resource |
| `createNote` | Boolean! | Indicates the user can perform `create_note` on this resource |
| `pushToSourceBranch` | Boolean! | Indicates the user can perform `push_to_source_branch` on this resource |
| `readMergeRequest` | Boolean! | Indicates the user can perform `read_merge_request` on this resource |
| `removeSourceBranch` | Boolean! | Indicates the user can perform `remove_source_branch` on this resource |
| `revertOnCurrentMergeRequest` | Boolean! | Indicates the user can perform `revert_on_current_merge_request` on this resource |
| `updateMergeRequest` | Boolean! | Indicates the user can perform `update_merge_request` on this resource |

## MergeRequestSetAssigneesPayload

Autogenerated return type of MergeRequestSetAssignees

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `mergeRequest` | MergeRequest | The merge request after mutation |

## MergeRequestSetLabelsPayload

Autogenerated return type of MergeRequestSetLabels

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `mergeRequest` | MergeRequest | The merge request after mutation |

## MergeRequestSetLockedPayload

Autogenerated return type of MergeRequestSetLocked

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `mergeRequest` | MergeRequest | The merge request after mutation |

## MergeRequestSetMilestonePayload

Autogenerated return type of MergeRequestSetMilestone

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `mergeRequest` | MergeRequest | The merge request after mutation |

## MergeRequestSetSubscriptionPayload

Autogenerated return type of MergeRequestSetSubscription

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `mergeRequest` | MergeRequest | The merge request after mutation |

## MergeRequestSetWipPayload

Autogenerated return type of MergeRequestSetWip

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `mergeRequest` | MergeRequest | The merge request after mutation |

## MergeRequestUpdatePayload

Autogenerated return type of MergeRequestUpdate

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `mergeRequest` | MergeRequest | The merge request after mutation |

## Metadata

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `revision` | String! | Revision |
| `version` | String! | Version |

## MetricsDashboard

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `path` | String | Path to a file with the dashboard definition |
| `schemaValidationWarnings` | String! => Array | Dashboard schema validation warnings |

## MetricsDashboardAnnotation

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `description` | String | Description of the annotation |
| `endingAt` | Time | Timestamp marking end of annotated time span |
| `id` | ID! | ID of the annotation |
| `panelId` | String | ID of a dashboard panel to which the annotation should be scoped |
| `startingAt` | Time | Timestamp marking start of annotated time span |

## Milestone

Represents a milestone.

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `createdAt` | Time! | Timestamp of milestone creation |
| `description` | String | Description of the milestone |
| `dueDate` | Time | Timestamp of the milestone due date |
| `groupMilestone` | Boolean! | Indicates if milestone is at group level |
| `id` | ID! | ID of the milestone |
| `projectMilestone` | Boolean! | Indicates if milestone is at project level |
| `startDate` | Time | Timestamp of the milestone start date |
| `state` | MilestoneStateEnum! | State of the milestone |
| `stats` | MilestoneStats | Milestone statistics |
| `subgroupMilestone` | Boolean! | Indicates if milestone is at subgroup level |
| `title` | String! | Title of the milestone |
| `updatedAt` | Time! | Timestamp of last milestone update |
| `webPath` | String! | Web path of the milestone |

## MilestoneStats

Contains statistics about a milestone

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `closedIssuesCount` | Int | Number of closed issues associated with the milestone |
| `totalIssuesCount` | Int | Total number of issues associated with the milestone |

## Namespace

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `description` | String | Description of the namespace |
| `descriptionHtml` | String | The GitLab Flavored Markdown rendering of `description` |
| `fullName` | String! | Full name of the namespace |
| `fullPath` | ID! | Full path of the namespace |
| `id` | ID! | ID of the namespace |
| `lfsEnabled` | Boolean | Indicates if Large File Storage (LFS) is enabled for namespace |
| `name` | String! | Name of the namespace |
| `path` | String! | Path of the namespace |
| `requestAccessEnabled` | Boolean | Indicates if users can request access to namespace |
| `rootStorageStatistics` | RootStorageStatistics | Aggregated storage statistics of the namespace. Only available for root namespaces |
| `storageSizeLimit` | Float | Total storage limit of the root namespace in bytes |
| `temporaryStorageIncreaseEndsOn` | Time | Date until the temporary storage increase is active |
| `visibility` | String | Visibility of the namespace |

## Note

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `author` | User! | User who wrote this note |
| `body` | String! | Content of the note |
| `bodyHtml` | String | The GitLab Flavored Markdown rendering of `note` |
| `confidential` | Boolean | Indicates if this note is confidential |
| `createdAt` | Time! | Timestamp of the note creation |
| `discussion` | Discussion | The discussion this note is a part of |
| `id` | ID! | ID of the note |
| `position` | DiffPosition | The position of this note on a diff |
| `project` | Project | Project associated with the note |
| `resolvable` | Boolean! | Indicates if the object can be resolved |
| `resolved` | Boolean! | Indicates if the object is resolved |
| `resolvedAt` | Time | Timestamp of when the object was resolved |
| `resolvedBy` | User | User who resolved the object |
| `system` | Boolean! | Indicates whether this note was created by the system or by a user |
| `systemNoteIconName` | String | Name of the icon corresponding to a system note |
| `updatedAt` | Time! | Timestamp of the note's last activity |
| `userPermissions` | NotePermissions! | Permissions for the current user on the resource |

## NotePermissions

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `adminNote` | Boolean! | Indicates the user can perform `admin_note` on this resource |
| `awardEmoji` | Boolean! | Indicates the user can perform `award_emoji` on this resource |
| `createNote` | Boolean! | Indicates the user can perform `create_note` on this resource |
| `readNote` | Boolean! | Indicates the user can perform `read_note` on this resource |
| `resolveNote` | Boolean! | Indicates the user can perform `resolve_note` on this resource |

## Package

Represents a package

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `createdAt` | Time! | The created date |
| `id` | ID! | The ID of the package |
| `name` | String! | The name of the package |
| `packageType` | PackageTypeEnum! | The type of the package |
| `updatedAt` | Time! | The update date |
| `version` | String | The version of the package |

## PackageFileRegistry

Represents the sync and verification state of a package file

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `createdAt` | Time | Timestamp when the PackageFileRegistry was created |
| `id` | ID! | ID of the PackageFileRegistry |
| `lastSyncFailure` | String | Error message during sync of the PackageFileRegistry |
| `lastSyncedAt` | Time | Timestamp of the most recent successful sync of the PackageFileRegistry |
| `packageFileId` | ID! | ID of the PackageFile |
| `retryAt` | Time | Timestamp after which the PackageFileRegistry should be resynced |
| `retryCount` | Int | Number of consecutive failed sync attempts of the PackageFileRegistry |
| `state` | RegistryState | Sync state of the PackageFileRegistry |

## PageInfo

Information about pagination in a connection.

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `endCursor` | String | When paginating forwards, the cursor to continue. |
| `hasNextPage` | Boolean! | When paginating forwards, are there more items? |
| `hasPreviousPage` | Boolean! | When paginating backwards, are there more items? |
| `startCursor` | String | When paginating backwards, the cursor to continue. |

## Pipeline

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `beforeSha` | String | Base SHA of the source branch |
| `committedAt` | Time | Timestamp of the pipeline's commit |
| `coverage` | Float | Coverage percentage |
| `createdAt` | Time! | Timestamp of the pipeline's creation |
| `detailedStatus` | DetailedStatus! | Detailed status of the pipeline |
| `duration` | Int | Duration of the pipeline in seconds |
| `finishedAt` | Time | Timestamp of the pipeline's completion |
| `id` | ID! | ID of the pipeline |
| `iid` | String! | Internal ID of the pipeline |
| `securityReportSummary` | SecurityReportSummary | Vulnerability and scanned resource counts for each security scanner of the pipeline |
| `sha` | String! | SHA of the pipeline's commit |
| `startedAt` | Time | Timestamp when the pipeline was started |
| `status` | PipelineStatusEnum! | Status of the pipeline (CREATED, WAITING_FOR_RESOURCE, PREPARING, PENDING, RUNNING, FAILED, SUCCESS, CANCELED, SKIPPED, MANUAL, SCHEDULED) |
| `updatedAt` | Time! | Timestamp of the pipeline's last activity |
| `userPermissions` | PipelinePermissions! | Permissions for the current user on the resource |

## PipelinePermissions

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `adminPipeline` | Boolean! | Indicates the user can perform `admin_pipeline` on this resource |
| `destroyPipeline` | Boolean! | Indicates the user can perform `destroy_pipeline` on this resource |
| `updatePipeline` | Boolean! | Indicates the user can perform `update_pipeline` on this resource |

## Project

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `alertManagementAlert` | AlertManagementAlert | A single Alert Management alert of the project |
| `alertManagementAlertStatusCounts` | AlertManagementAlertStatusCountsType | Counts of alerts by status for the project |
| `allowMergeOnSkippedPipeline` | Boolean | If `only_allow_merge_if_pipeline_succeeds` is true, indicates if merge requests of the project can also be merged with skipped jobs |
| `archived` | Boolean | Indicates the archived status of the project |
| `autocloseReferencedIssues` | Boolean | Indicates if issues referenced by merge requests and commits within the default branch are closed automatically |
| `avatarUrl` | String | URL to avatar image file of the project |
| `board` | Board | A single board of the project |
| `containerExpirationPolicy` | ContainerExpirationPolicy | The container expiration policy of the project |
| `containerRegistryEnabled` | Boolean | Indicates if the project stores Docker container images in a container registry |
| `createdAt` | Time | Timestamp of the project creation |
| `description` | String | Short description of the project |
| `descriptionHtml` | String | The GitLab Flavored Markdown rendering of `description` |
| `forksCount` | Int! | Number of times the project has been forked |
| `fullPath` | ID! | Full path of the project |
| `grafanaIntegration` | GrafanaIntegration | Grafana integration details for the project |
| `group` | Group | Group of the project |
| `httpUrlToRepo` | String | URL to connect to the project via HTTPS |
| `id` | ID! | ID of the project |
| `importStatus` | String | Status of import background job of the project |
| `issue` | Issue | A single issue of the project |
| `issuesEnabled` | Boolean | Indicates if Issues are enabled for the current user |
| `jiraImportStatus` | String | Status of Jira import background job of the project |
| `jobsEnabled` | Boolean | Indicates if CI/CD pipeline jobs are enabled for the current user |
| `label` | Label | A label available on this project |
| `lastActivityAt` | Time | Timestamp of the project last activity |
| `lfsEnabled` | Boolean | Indicates if the project has Large File Storage (LFS) enabled |
| `mergeRequest` | MergeRequest | A single merge request of the project |
| `mergeRequestsEnabled` | Boolean | Indicates if Merge Requests are enabled for the current user |
| `mergeRequestsFfOnlyEnabled` | Boolean | Indicates if no merge commits should be created and all merges should instead be fast-forwarded, which means that merging is only allowed if the branch could be fast-forwarded. |
| `name` | String! | Name of the project (without namespace) |
| `nameWithNamespace` | String! | Full name of the project with its namespace |
| `namespace` | Namespace | Namespace of the project |
| `onlyAllowMergeIfAllDiscussionsAreResolved` | Boolean | Indicates if merge requests of the project can only be merged when all the discussions are resolved |
| `onlyAllowMergeIfPipelineSucceeds` | Boolean | Indicates if merge requests of the project can only be merged with successful jobs |
| `openIssuesCount` | Int | Number of open issues for the project |
| `path` | String! | Path of the project |
| `pipeline` | Pipeline | Build pipeline of the project |
| `printingMergeRequestLinkEnabled` | Boolean | Indicates if a link to create or view a merge request should display after a push to Git repositories of the project from the command line |
| `publicJobs` | Boolean | Indicates if there is public access to pipelines and job details of the project, including output logs and artifacts |
| `release` | Release | A single release of the project |
| `removeSourceBranchAfterMerge` | Boolean | Indicates if `Delete source branch` option should be enabled by default for all new merge requests of the project |
| `repository` | Repository | Git repository of the project |
| `requestAccessEnabled` | Boolean | Indicates if users can request member access to the project |
| `requirement` | Requirement | Find a single requirement. Available only when feature flag `requirements_management` is enabled. |
| `requirementStatesCount` | RequirementStatesCount | Number of requirements for the project by their state |
| `sastCiConfiguration` | SastCiConfiguration | SAST CI configuration for the project |
| `securityScanners` | SecurityScanners | Information about security analyzers used in the project |
| `sentryDetailedError` | SentryDetailedError | Detailed version of a Sentry error on the project |
| `sentryErrors` | SentryErrorCollection | Paginated collection of Sentry errors on the project |
| `serviceDeskAddress` | String | E-mail address of the service desk. |
| `serviceDeskEnabled` | Boolean | Indicates if the project has service desk enabled. |
| `sharedRunnersEnabled` | Boolean | Indicates if Shared Runners are enabled for the project |
| `snippetsEnabled` | Boolean | Indicates if Snippets are enabled for the current user |
| `sshUrlToRepo` | String | URL to connect to the project via SSH |
| `starCount` | Int! | Number of times the project has been starred |
| `statistics` | ProjectStatistics | Statistics of the project |
| `suggestionCommitMessage` | String | The commit message used to apply merge request suggestions |
| `tagList` | String | List of project topics (not Git tags) |
| `userPermissions` | ProjectPermissions! | Permissions for the current user on the resource |
| `visibility` | String | Visibility of the project |
| `vulnerabilitySeveritiesCount` | VulnerabilitySeveritiesCount | Counts for each severity of vulnerability of the project |
| `webUrl` | String | Web URL of the project |
| `wikiEnabled` | Boolean | Indicates if Wikis are enabled for the current user |

## ProjectMember

Represents a Project Member

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `accessLevel` | AccessLevel | GitLab::Access level |
| `createdAt` | Time | Date and time the membership was created |
| `createdBy` | User | User that authorized membership |
| `expiresAt` | Time | Date and time the membership expires |
| `id` | ID! | ID of the member |
| `project` | Project | Project that User is a member of |
| `updatedAt` | Time | Date and time the membership was last updated |
| `user` | User! | User that is associated with the member object |
| `userPermissions` | ProjectPermissions! | Permissions for the current user on the resource |

## ProjectPermissions

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `adminOperations` | Boolean! | Indicates the user can perform `admin_operations` on this resource |
| `adminProject` | Boolean! | Indicates the user can perform `admin_project` on this resource |
| `adminRemoteMirror` | Boolean! | Indicates the user can perform `admin_remote_mirror` on this resource |
| `adminWiki` | Boolean! | Indicates the user can perform `admin_wiki` on this resource |
| `archiveProject` | Boolean! | Indicates the user can perform `archive_project` on this resource |
| `changeNamespace` | Boolean! | Indicates the user can perform `change_namespace` on this resource |
| `changeVisibilityLevel` | Boolean! | Indicates the user can perform `change_visibility_level` on this resource |
| `createDeployment` | Boolean! | Indicates the user can perform `create_deployment` on this resource |
| `createDesign` | Boolean! | Indicates the user can perform `create_design` on this resource |
| `createIssue` | Boolean! | Indicates the user can perform `create_issue` on this resource |
| `createLabel` | Boolean! | Indicates the user can perform `create_label` on this resource |
| `createMergeRequestFrom` | Boolean! | Indicates the user can perform `create_merge_request_from` on this resource |
| `createMergeRequestIn` | Boolean! | Indicates the user can perform `create_merge_request_in` on this resource |
| `createPages` | Boolean! | Indicates the user can perform `create_pages` on this resource |
| `createPipeline` | Boolean! | Indicates the user can perform `create_pipeline` on this resource |
| `createPipelineSchedule` | Boolean! | Indicates the user can perform `create_pipeline_schedule` on this resource |
| `createSnippet` | Boolean! | Indicates the user can perform `create_snippet` on this resource |
| `createWiki` | Boolean! | Indicates the user can perform `create_wiki` on this resource |
| `destroyDesign` | Boolean! | Indicates the user can perform `destroy_design` on this resource |
| `destroyPages` | Boolean! | Indicates the user can perform `destroy_pages` on this resource |
| `destroyWiki` | Boolean! | Indicates the user can perform `destroy_wiki` on this resource |
| `downloadCode` | Boolean! | Indicates the user can perform `download_code` on this resource |
| `downloadWikiCode` | Boolean! | Indicates the user can perform `download_wiki_code` on this resource |
| `forkProject` | Boolean! | Indicates the user can perform `fork_project` on this resource |
| `pushCode` | Boolean! | Indicates the user can perform `push_code` on this resource |
| `pushToDeleteProtectedBranch` | Boolean! | Indicates the user can perform `push_to_delete_protected_branch` on this resource |
| `readCommitStatus` | Boolean! | Indicates the user can perform `read_commit_status` on this resource |
| `readCycleAnalytics` | Boolean! | Indicates the user can perform `read_cycle_analytics` on this resource |
| `readDesign` | Boolean! | Indicates the user can perform `read_design` on this resource |
| `readMergeRequest` | Boolean! | Indicates the user can perform `read_merge_request` on this resource |
| `readPagesContent` | Boolean! | Indicates the user can perform `read_pages_content` on this resource |
| `readProject` | Boolean! | Indicates the user can perform `read_project` on this resource |
| `readProjectMember` | Boolean! | Indicates the user can perform `read_project_member` on this resource |
| `readWiki` | Boolean! | Indicates the user can perform `read_wiki` on this resource |
| `removeForkProject` | Boolean! | Indicates the user can perform `remove_fork_project` on this resource |
| `removePages` | Boolean! | Indicates the user can perform `remove_pages` on this resource |
| `removeProject` | Boolean! | Indicates the user can perform `remove_project` on this resource |
| `renameProject` | Boolean! | Indicates the user can perform `rename_project` on this resource |
| `requestAccess` | Boolean! | Indicates the user can perform `request_access` on this resource |
| `updatePages` | Boolean! | Indicates the user can perform `update_pages` on this resource |
| `updateWiki` | Boolean! | Indicates the user can perform `update_wiki` on this resource |
| `uploadFile` | Boolean! | Indicates the user can perform `upload_file` on this resource |

## ProjectStatistics

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `buildArtifactsSize` | Float! | Build artifacts size of the project |
| `commitCount` | Float! | Commit count of the project |
| `lfsObjectsSize` | Float! | Large File Storage (LFS) object size of the project |
| `packagesSize` | Float! | Packages size of the project |
| `repositorySize` | Float! | Repository size of the project |
| `snippetsSize` | Float | Snippets size of the project |
| `storageSize` | Float! | Storage size of the project |
| `wikiSize` | Float | Wiki size of the project |

## Release

Represents a release

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `assets` | ReleaseAssets | Assets of the release |
| `author` | User | User that created the release |
| `commit` | Commit | The commit associated with the release |
| `createdAt` | Time | Timestamp of when the release was created |
| `description` | String | Description (also known as "release notes") of the release |
| `descriptionHtml` | String | The GitLab Flavored Markdown rendering of `description` |
| `links` | ReleaseLinks | Links of the release |
| `name` | String | Name of the release |
| `releasedAt` | Time | Timestamp of when the release was released |
| `tagName` | String | Name of the tag associated with the release |
| `tagPath` | String | Relative web path to the tag associated with the release |

## ReleaseAssetLink

Represents an asset link associated with a release

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `external` | Boolean | Indicates the link points to an external resource |
| `id` | ID! | ID of the link |
| `linkType` | ReleaseAssetLinkType | Type of the link: `other`, `runbook`, `image`, `package`; defaults to `other` |
| `name` | String | Name of the link |
| `url` | String | URL of the link |

## ReleaseAssets

A container for all assets associated with a release

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `count` | Int | Number of assets of the release |

## ReleaseEvidence

Evidence for a release

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `collectedAt` | Time | Timestamp when the evidence was collected |
| `filepath` | String | URL from where the evidence can be downloaded |
| `id` | ID! | ID of the evidence |
| `sha` | String | SHA1 ID of the evidence hash |

## ReleaseLinks

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `editUrl` | String | HTTP URL of the release's edit page |
| `issuesUrl` | String | HTTP URL of the issues page filtered by this release |
| `mergeRequestsUrl` | String | HTTP URL of the merge request page filtered by this release |
| `selfUrl` | String | HTTP URL of the release |

## ReleaseSource

Represents the source code attached to a release in a particular format

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `format` | String | Format of the source |
| `url` | String | Download URL of the source |

## RemoveAwardEmojiPayload

Autogenerated return type of RemoveAwardEmoji

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `awardEmoji` | AwardEmoji | The award emoji after mutation |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |

## RemoveProjectFromSecurityDashboardPayload

Autogenerated return type of RemoveProjectFromSecurityDashboard

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |

## Repository

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `empty` | Boolean! | Indicates repository has no visible content |
| `exists` | Boolean! | Indicates a corresponding Git repository exists on disk |
| `rootRef` | String | Default branch of the repository |
| `tree` | Tree | Tree of the repository |

## Requirement

Represents a requirement

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `author` | User! | Author of the requirement |
| `createdAt` | Time! | Timestamp of when the requirement was created |
| `id` | ID! | ID of the requirement |
| `iid` | ID! | Internal ID of the requirement |
| `project` | Project! | Project to which the requirement belongs |
| `state` | RequirementState! | State of the requirement |
| `title` | String | Title of the requirement |
| `updatedAt` | Time! | Timestamp of when the requirement was last updated |
| `userPermissions` | RequirementPermissions! | Permissions for the current user on the resource |

## RequirementPermissions

Check permissions for the current user on a requirement

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `adminRequirement` | Boolean! | Indicates the user can perform `admin_requirement` on this resource |
| `createRequirement` | Boolean! | Indicates the user can perform `create_requirement` on this resource |
| `destroyRequirement` | Boolean! | Indicates the user can perform `destroy_requirement` on this resource |
| `readRequirement` | Boolean! | Indicates the user can perform `read_requirement` on this resource |
| `updateRequirement` | Boolean! | Indicates the user can perform `update_requirement` on this resource |

## RequirementStatesCount

Counts of requirements by their state.

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `archived` | Int | Number of archived requirements |
| `opened` | Int | Number of opened requirements |

## RootStorageStatistics

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `buildArtifactsSize` | Float! | The CI artifacts size in bytes |
| `lfsObjectsSize` | Float! | The LFS objects size in bytes |
| `packagesSize` | Float! | The packages size in bytes |
| `repositorySize` | Float! | The Git repository size in bytes |
| `snippetsSize` | Float! | The snippets size in bytes |
| `storageSize` | Float! | The total storage in bytes |
| `wikiSize` | Float! | The wiki size in bytes |

## RunDASTScanPayload

Autogenerated return type of RunDASTScan

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `pipelineUrl` | String | URL of the pipeline that was created. |

## SastCiConfigurationAnalyzersEntity

Represents an analyzer entity in SAST CI configuration

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `description` | String | Analyzer description that is displayed on the form. |
| `enabled` | Boolean | Indicates whether an analyzer is enabled. |
| `label` | String | Analyzer label used in the config UI. |
| `name` | String | Name of the analyzer. |

## SastCiConfigurationEntity

Represents an entity in SAST CI configuration

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `defaultValue` | String | Default value that is used if value is empty. |
| `description` | String | Entity description that is displayed on the form. |
| `field` | String | CI keyword of entity. |
| `label` | String | Label for entity used in the form. |
| `type` | String | Type of the field value. |
| `value` | String | Current value of the entity. |

## SastCiConfigurationOptionsEntity

Represents an entity for options in SAST CI configuration

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `label` | String | Label of option entity. |
| `value` | String | Value of option entity. |

## ScannedResource

Represents a resource scanned by a security scan

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `requestMethod` | String | The HTTP request method used to access the URL |
| `url` | String | The URL scanned by the scanner |

## SecurityReportSummary

Represents summary of a security report

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `containerScanning` | SecurityReportSummarySection | Aggregated counts for the container_scanning scan |
| `coverageFuzzing` | SecurityReportSummarySection | Aggregated counts for the coverage_fuzzing scan |
| `dast` | SecurityReportSummarySection | Aggregated counts for the dast scan |
| `dependencyScanning` | SecurityReportSummarySection | Aggregated counts for the dependency_scanning scan |
| `sast` | SecurityReportSummarySection | Aggregated counts for the sast scan |
| `secretDetection` | SecurityReportSummarySection | Aggregated counts for the secret_detection scan |

## SecurityReportSummarySection

Represents a section of a summary of a security report

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `scannedResourcesCount` | Int | Total number of scanned resources |
| `scannedResourcesCsvPath` | String | Path to download all the scanned resources in CSV format |
| `vulnerabilitiesCount` | Int | Total number of vulnerabilities |

## SecurityScanners

Represents a list of security scanners

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `available` | SecurityScannerType! => Array | List of analyzers which are available for the project. |
| `enabled` | SecurityScannerType! => Array | List of analyzers which are enabled for the project. |
| `pipelineRun` | SecurityScannerType! => Array | List of analyzers which ran successfully in the latest pipeline. |

## SentryDetailedError

A Sentry error.

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `count` | Int! | Count of occurrences |
| `culprit` | String! | Culprit of the error |
| `externalBaseUrl` | String! | External Base URL of the Sentry Instance |
| `externalUrl` | String! | External URL of the error |
| `firstReleaseLastCommit` | String | Commit the error was first seen |
| `firstReleaseShortVersion` | String | Release short version the error was first seen |
| `firstReleaseVersion` | String | Release version the error was first seen |
| `firstSeen` | Time! | Timestamp when the error was first seen |
| `frequency` | SentryErrorFrequency! => Array | Last 24hr stats of the error |
| `gitlabCommit` | String | GitLab commit SHA attributed to the Error based on the release version |
| `gitlabCommitPath` | String | Path to the GitLab page for the GitLab commit attributed to the error |
| `gitlabIssuePath` | String | URL of GitLab Issue |
| `id` | ID! | ID (global ID) of the error |
| `lastReleaseLastCommit` | String | Commit the error was last seen |
| `lastReleaseShortVersion` | String | Release short version the error was last seen |
| `lastReleaseVersion` | String | Release version the error was last seen |
| `lastSeen` | Time! | Timestamp when the error was last seen |
| `message` | String | Sentry metadata message of the error |
| `sentryId` | String! | ID (Sentry ID) of the error |
| `sentryProjectId` | ID! | ID of the project (Sentry project) |
| `sentryProjectName` | String! | Name of the project affected by the error |
| `sentryProjectSlug` | String! | Slug of the project affected by the error |
| `shortId` | String! | Short ID (Sentry ID) of the error |
| `status` | SentryErrorStatus! | Status of the error |
| `tags` | SentryErrorTags! | Tags associated with the Sentry Error |
| `title` | String! | Title of the error |
| `type` | String! | Type of the error |
| `userCount` | Int! | Count of users affected by the error |

## SentryError

A Sentry error. A simplified version of SentryDetailedError.

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `count` | Int! | Count of occurrences |
| `culprit` | String! | Culprit of the error |
| `externalUrl` | String! | External URL of the error |
| `firstSeen` | Time! | Timestamp when the error was first seen |
| `frequency` | SentryErrorFrequency! => Array | Last 24hr stats of the error |
| `id` | ID! | ID (global ID) of the error |
| `lastSeen` | Time! | Timestamp when the error was last seen |
| `message` | String | Sentry metadata message of the error |
| `sentryId` | String! | ID (Sentry ID) of the error |
| `sentryProjectId` | ID! | ID of the project (Sentry project) |
| `sentryProjectName` | String! | Name of the project affected by the error |
| `sentryProjectSlug` | String! | Slug of the project affected by the error |
| `shortId` | String! | Short ID (Sentry ID) of the error |
| `status` | SentryErrorStatus! | Status of the error |
| `title` | String! | Title of the error |
| `type` | String! | Type of the error |
| `userCount` | Int! | Count of users affected by the error |

## SentryErrorCollection

An object containing a collection of Sentry errors, and a detailed error.

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `detailedError` | SentryDetailedError | Detailed version of a Sentry error on the project |
| `errorStackTrace` | SentryErrorStackTrace | Stack Trace of Sentry Error |
| `errors` | SentryErrorConnection | Collection of Sentry Errors |
| `externalUrl` | String | External URL for Sentry |

## SentryErrorFrequency

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `count` | Int! | Count of errors received since the previously recorded time |
| `time` | Time! | Time the error frequency stats were recorded |

## SentryErrorStackTrace

An object containing a stack trace entry for a Sentry error.

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `dateReceived` | String! | Time the stack trace was received by Sentry |
| `issueId` | String! | ID of the Sentry error |
| `stackTraceEntries` | SentryErrorStackTraceEntry! => Array | Stack trace entries for the Sentry error |

## SentryErrorStackTraceContext

An object context for a Sentry error stack trace

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `code` | String! | Code number of the context |
| `line` | Int! | Line number of the context |

## SentryErrorStackTraceEntry

An object containing a stack trace entry for a Sentry error.

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `col` | String | Function in which the Sentry error occurred |
| `fileName` | String | File in which the Sentry error occurred |
| `function` | String | Function in which the Sentry error occurred |
| `line` | String | Function in which the Sentry error occurred |
| `traceContext` | SentryErrorStackTraceContext! => Array | Context of the Sentry error |

## SentryErrorTags

State of a Sentry error

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `level` | String | Severity level of the Sentry Error |
| `logger` | String | Logger of the Sentry Error |

## Snippet

Represents a snippet entry

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `author` | User | The owner of the snippet |
| `blob` | SnippetBlob! | Snippet blob |
| `blobs` | SnippetBlob! => Array | Snippet blobs |
| `createdAt` | Time! | Timestamp this snippet was created |
| `description` | String | Description of the snippet |
| `descriptionHtml` | String | The GitLab Flavored Markdown rendering of `description` |
| `fileName` | String | File Name of the snippet |
| `httpUrlToRepo` | String | HTTP URL to the snippet repository |
| `id` | ID! | ID of the snippet |
| `project` | Project | The project the snippet is associated with |
| `rawUrl` | String! | Raw URL of the snippet |
| `sshUrlToRepo` | String | SSH URL to the snippet repository |
| `title` | String! | Title of the snippet |
| `updatedAt` | Time! | Timestamp this snippet was updated |
| `userPermissions` | SnippetPermissions! | Permissions for the current user on the resource |
| `visibilityLevel` | VisibilityLevelsEnum! | Visibility Level of the snippet |
| `webUrl` | String! | Web URL of the snippet |

## SnippetBlob

Represents the snippet blob

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `binary` | Boolean! | Shows whether the blob is binary |
| `externalStorage` | String | Blob external storage |
| `mode` | String | Blob mode |
| `name` | String | Blob name |
| `path` | String | Blob path |
| `plainData` | String | Blob plain highlighted data |
| `rawPath` | String! | Blob raw content endpoint path |
| `renderedAsText` | Boolean! | Shows whether the blob is rendered as text |
| `richData` | String | Blob highlighted data |
| `richViewer` | SnippetBlobViewer | Blob content rich viewer |
| `simpleViewer` | SnippetBlobViewer! | Blob content simple viewer |
| `size` | Int! | Blob size |

## SnippetBlobViewer

Represents how the blob content should be displayed

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `collapsed` | Boolean! | Shows whether the blob should be displayed collapsed |
| `fileType` | String! | Content file type |
| `loadAsync` | Boolean! | Shows whether the blob content is loaded async |
| `loadingPartialName` | String! | Loading partial name |
| `renderError` | String | Error rendering the blob content |
| `tooLarge` | Boolean! | Shows whether the blob too large to be displayed |
| `type` | BlobViewersType! | Type of blob viewer |

## SnippetPermissions

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `adminSnippet` | Boolean! | Indicates the user can perform `admin_snippet` on this resource |
| `awardEmoji` | Boolean! | Indicates the user can perform `award_emoji` on this resource |
| `createNote` | Boolean! | Indicates the user can perform `create_note` on this resource |
| `readSnippet` | Boolean! | Indicates the user can perform `read_snippet` on this resource |
| `reportSnippet` | Boolean! | Indicates the user can perform `report_snippet` on this resource |
| `updateSnippet` | Boolean! | Indicates the user can perform `update_snippet` on this resource |

## Submodule

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `flatPath` | String! | Flat path of the entry |
| `id` | ID! | ID of the entry |
| `name` | String! | Name of the entry |
| `path` | String! | Path of the entry |
| `sha` | String! | Last commit sha for the entry |
| `treeUrl` | String | Tree URL for the sub-module |
| `type` | EntryType! | Type of tree entry |
| `webUrl` | String | Web URL for the sub-module |

## TaskCompletionStatus

Completion status of tasks

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `completedCount` | Int! | Number of completed tasks |
| `count` | Int! | Number of total tasks |

## TestReport

Represents a requirement test report.

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `author` | User | Author of the test report |
| `createdAt` | Time! | Timestamp of when the test report was created |
| `id` | ID! | ID of the test report |
| `state` | TestReportState! | State of the test report |

## Timelog

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `date` **{warning-solid}** | Time! | **Deprecated:** Use `spentAt`. Deprecated in 12.10 |
| `issue` | Issue | The issue that logged time was added to |
| `spentAt` | Time | Timestamp of when the time tracked was spent at |
| `timeSpent` | Int! | The time spent displayed in seconds |
| `user` | User! | The user that logged the time |

## Todo

Representing a todo entry

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `action` | TodoActionEnum! | Action of the todo |
| `author` | User! | The owner of this todo |
| `body` | String! | Body of the todo |
| `createdAt` | Time! | Timestamp this todo was created |
| `group` | Group | Group this todo is associated with |
| `id` | ID! | ID of the todo |
| `project` | Project | The project this todo is associated with |
| `state` | TodoStateEnum! | State of the todo |
| `targetType` | TodoTargetEnum! | Target type of the todo |

## TodoMarkDonePayload

Autogenerated return type of TodoMarkDone

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `todo` | Todo! | The requested todo |

## TodoRestoreManyPayload

Autogenerated return type of TodoRestoreMany

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `todos` | Todo! => Array | Updated todos |
| `updatedIds` **{warning-solid}** | ID! => Array | **Deprecated:** Use todos. Deprecated in 13.2 |

## TodoRestorePayload

Autogenerated return type of TodoRestore

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `todo` | Todo! | The requested todo |

## TodosMarkAllDonePayload

Autogenerated return type of TodosMarkAllDone

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `todos` | Todo! => Array | Updated todos |
| `updatedIds` **{warning-solid}** | ID! => Array | **Deprecated:** Use todos. Deprecated in 13.2 |

## ToggleAwardEmojiPayload

Autogenerated return type of ToggleAwardEmoji

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `awardEmoji` | AwardEmoji | The award emoji after mutation |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `toggledOn` | Boolean! | Indicates the status of the emoji. True if the toggle awarded the emoji, and false if the toggle removed the emoji. |

## Tree

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `lastCommit` | Commit | Last commit for the tree |

## TreeEntry

Represents a directory

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `flatPath` | String! | Flat path of the entry |
| `id` | ID! | ID of the entry |
| `name` | String! | Name of the entry |
| `path` | String! | Path of the entry |
| `sha` | String! | Last commit sha for the entry |
| `type` | EntryType! | Type of tree entry |
| `webPath` | String | Web path for the tree entry (directory) |
| `webUrl` | String | Web URL for the tree entry (directory) |

## UpdateAlertStatusPayload

Autogenerated return type of UpdateAlertStatus

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `alert` | AlertManagementAlert | The alert after mutation |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `issue` | Issue | The issue created after mutation |
| `todo` | Todo | The todo after mutation |

## UpdateContainerExpirationPolicyPayload

Autogenerated return type of UpdateContainerExpirationPolicy

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `containerExpirationPolicy` | ContainerExpirationPolicy | The container expiration policy after mutation |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |

## UpdateEpicPayload

Autogenerated return type of UpdateEpic

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `epic` | Epic | The epic after mutation |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |

## UpdateImageDiffNotePayload

Autogenerated return type of UpdateImageDiffNote

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `note` | Note | The note after mutation |

## UpdateIssuePayload

Autogenerated return type of UpdateIssue

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `issue` | Issue | The issue after mutation |

## UpdateIterationPayload

Autogenerated return type of UpdateIteration

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `iteration` | Iteration | The updated iteration |

## UpdateNotePayload

Autogenerated return type of UpdateNote

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `note` | Note | The note after mutation |

## UpdateRequirementPayload

Autogenerated return type of UpdateRequirement

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `requirement` | Requirement | The requirement after mutation |

## UpdateSnippetPayload

Autogenerated return type of UpdateSnippet

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `clientMutationId` | String | A unique identifier for the client performing the mutation. |
| `errors` | String! => Array | Errors encountered during execution of the mutation. |
| `snippet` | Snippet | The snippet after mutation |

## User

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `avatarUrl` | String | URL of the user's avatar |
| `id` | ID! | ID of the user |
| `name` | String! | Human-readable name of the user |
| `state` | UserState! | State of the user |
| `userPermissions` | UserPermissions! | Permissions for the current user on the resource |
| `username` | String! | Username of the user. Unique within this instance of GitLab |
| `webPath` | String! | Web path of the user |
| `webUrl` | String! | Web URL of the user |

## UserPermissions

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `createSnippet` | Boolean! | Indicates the user can perform `create_snippet` on this resource |

## VulnerabilitiesCountByDayAndSeverity

Represents the number of vulnerabilities for a particular severity on a particular day

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `count` | Int | Number of vulnerabilities |
| `day` | ISO8601Date | Date for the count |
| `severity` | VulnerabilitySeverity | Severity of the counted vulnerabilities |

## Vulnerability

Represents a vulnerability.

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `description` | String | Description of the vulnerability |
| `id` | ID! | GraphQL ID of the vulnerability |
| `identifiers` | VulnerabilityIdentifier! => Array | Identifiers of the vulnerability. |
| `location` | VulnerabilityLocation | Location metadata for the vulnerability. Its fields depend on the type of security scan that found the vulnerability |
| `primaryIdentifier` | VulnerabilityIdentifier | Primary identifier of the vulnerability. |
| `project` | Project | The project on which the vulnerability was found |
| `reportType` | VulnerabilityReportType | Type of the security report that found the vulnerability (SAST, DEPENDENCY_SCANNING, CONTAINER_SCANNING, DAST, SECRET_DETECTION, COVERAGE_FUZZING) |
| `scanner` | VulnerabilityScanner | Scanner metadata for the vulnerability. |
| `severity` | VulnerabilitySeverity | Severity of the vulnerability (INFO, UNKNOWN, LOW, MEDIUM, HIGH, CRITICAL) |
| `state` | VulnerabilityState | State of the vulnerability (DETECTED, DISMISSED, RESOLVED, CONFIRMED) |
| `title` | String | Title of the vulnerability |
| `userNotesCount` | Int! | Number of user notes attached to the vulnerability |
| `userPermissions` | VulnerabilityPermissions! | Permissions for the current user on the resource |
| `vulnerabilityPath` | String | URL to the vulnerability's details page |

## VulnerabilityIdentifier

Represents a vulnerability identifier.

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `externalId` | String | External ID of the vulnerability identifier |
| `externalType` | String | External type of the vulnerability identifier |
| `name` | String | Name of the vulnerability identifier |
| `url` | String | URL of the vulnerability identifier |

## VulnerabilityIssueLink

Represents an issue link of a vulnerability.

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `id` | ID! | GraphQL ID of the vulnerability |
| `issue` | Issue! | The issue attached to issue link |
| `linkType` | VulnerabilityIssueLinkType! | Type of the issue link |

## VulnerabilityLocationContainerScanning

Represents the location of a vulnerability found by a container security scan

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `dependency` | VulnerableDependency | Dependency containing the vulnerability |
| `image` | String | Name of the vulnerable container image |
| `operatingSystem` | String | Operating system that runs on the vulnerable container image |

## VulnerabilityLocationCoverageFuzzing

Represents the location of a vulnerability found by a Coverage Fuzzing scan

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `endLine` | String | Number of the last relevant line in the vulnerable file |
| `file` | String | Path to the vulnerable file |
| `startLine` | String | Number of the first relevant line in the vulnerable file |
| `vulnerableClass` | String | Class containing the vulnerability |
| `vulnerableMethod` | String | Method containing the vulnerability |

## VulnerabilityLocationDast

Represents the location of a vulnerability found by a DAST scan

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `hostname` | String | Domain name of the vulnerable request |
| `param` | String | Query parameter for the URL on which the vulnerability occurred |
| `path` | String | URL path and query string of the vulnerable request |
| `requestMethod` | String | HTTP method of the vulnerable request |

## VulnerabilityLocationDependencyScanning

Represents the location of a vulnerability found by a dependency security scan

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `dependency` | VulnerableDependency | Dependency containing the vulnerability |
| `file` | String | Path to the vulnerable file |

## VulnerabilityLocationSast

Represents the location of a vulnerability found by a SAST scan

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `endLine` | String | Number of the last relevant line in the vulnerable file |
| `file` | String | Path to the vulnerable file |
| `startLine` | String | Number of the first relevant line in the vulnerable file |
| `vulnerableClass` | String | Class containing the vulnerability |
| `vulnerableMethod` | String | Method containing the vulnerability |

## VulnerabilityLocationSecretDetection

Represents the location of a vulnerability found by a secret detection scan

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `endLine` | String | Number of the last relevant line in the vulnerable file |
| `file` | String | Path to the vulnerable file |
| `startLine` | String | Number of the first relevant line in the vulnerable file |
| `vulnerableClass` | String | Class containing the vulnerability |
| `vulnerableMethod` | String | Method containing the vulnerability |

## VulnerabilityPermissions

Check permissions for the current user on a vulnerability

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `adminVulnerability` | Boolean! | Indicates the user can perform `admin_vulnerability` on this resource |
| `adminVulnerabilityIssueLink` | Boolean! | Indicates the user can perform `admin_vulnerability_issue_link` on this resource |
| `createVulnerability` | Boolean! | Indicates the user can perform `create_vulnerability` on this resource |
| `createVulnerabilityExport` | Boolean! | Indicates the user can perform `create_vulnerability_export` on this resource |
| `createVulnerabilityFeedback` | Boolean! | Indicates the user can perform `create_vulnerability_feedback` on this resource |
| `destroyVulnerabilityFeedback` | Boolean! | Indicates the user can perform `destroy_vulnerability_feedback` on this resource |
| `readVulnerabilityFeedback` | Boolean! | Indicates the user can perform `read_vulnerability_feedback` on this resource |
| `updateVulnerabilityFeedback` | Boolean! | Indicates the user can perform `update_vulnerability_feedback` on this resource |

## VulnerabilityScanner

Represents a vulnerability scanner.

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `externalId` | String | External ID of the vulnerability scanner |
| `name` | String | Name of the vulnerability scanner |
| `reportType` | VulnerabilityReportType | Type of the vulnerability report |
| `vendor` | String | Vendor of the vulnerability scanner |

## VulnerabilitySeveritiesCount

Represents vulnerability counts by severity

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `critical` | Int | Number of vulnerabilities of CRITICAL severity of the project |
| `high` | Int | Number of vulnerabilities of HIGH severity of the project |
| `info` | Int | Number of vulnerabilities of INFO severity of the project |
| `low` | Int | Number of vulnerabilities of LOW severity of the project |
| `medium` | Int | Number of vulnerabilities of MEDIUM severity of the project |
| `unknown` | Int | Number of vulnerabilities of UNKNOWN severity of the project |

## VulnerableDependency

Represents a vulnerable dependency. Used in vulnerability location data

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `package` | VulnerablePackage | The package associated with the vulnerable dependency |
| `version` | String | The version of the vulnerable dependency |

## VulnerablePackage

Represents a vulnerable package. Used in vulnerability dependency data

| Name  | Type  | Description |
| ---   |  ---- | ----------  |
| `name` | String | The name of the vulnerable package |
